# -*- coding: utf-8 -*-
## funittest
## Functional test automation stack
## Copyright (C)2007 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from zope.interface import implements
from zope.component import provideUtility, queryUtility

from interfaces import IConfiguration

from ConfigParser import ConfigParser


DEFAULT_CONFIG='funittest.cfg'

class Configuration(object):
    """Funittest extented configuration.
    """

    implements(IConfiguration)

    def __init__(self, filename='funittest.cfg'):
        self._config = ConfigParser()
        self._config.read(filename)
        self._default = dict()

    def _section(self, section):
        if self._config.has_section(section):
            return dict(self._config.items(section))
        if self._default.has_key(section):
            return self._default[section]
        return dict()

    def set_configuration(self, section, configuration):
        if not isinstance(configuration, dict):
            raise ValueError, "Configuration should a dictionary."
        if not self._default.has_key(section):
            self._default[section] = dict()
        self._default[section].update(configuration)

    def default(self):
        return self._section('default')

    def log(self):
        return self._section('log')

    def browser(self):
        return self._section('browser')

def loadConfiguration(filename):
    config = Configuration(filename)
    provideUtility(config, IConfiguration, 'core')
    return config

def retrieveConfiguration():
    config = queryUtility(IConfiguration, 'core')
    if config is None:
        config = loadConfiguration(DEFAULT_CONFIG)
    return config

def get_browser_config():
    config = retrieveConfiguration()
    browser_config = config.browser()
    browser_type = browser_config.get('type', 'firefox')
    browser_url = browser_config.get('url', None)
    return browser_type, browser_url
    
