from zope.interface import implements, Attribute
from funittest import ObjectEvent
from funittest import IObjectEvent

# Event for tests

class ITestStarting(IObjectEvent):
    """Event triggered when you start an Policy Test.
    """

    test_ids = Attribute(u"Test ID")

class ITestEnding(IObjectEvent):
    """Event triggered when you finish an Policy Test.
    """


# Implementation of theses events

class TestStarting(ObjectEvent):
    implements(ITestStarting)

    def __init__(self, test, *ids):
        super(TestStarting, self).__init__(test)
        self.test_ids = [test.get_name(), ] + list(ids)

class TestEnding(ObjectEvent):
    implements(ITestEnding)

    


