import os
import unittest
from zope.interface import implements

from funittest.core.interfaces import IExpectedStateGenerator
from funittest.core.interfaces import ILogical
from funittest.core.interfaces import IPhysical
from funittest.core.interfaces import IScript

from funittest.registry.dataprovider import DataProvider
from funittest.registry.dataprovider import PolicyDataProvider
from funittest.registry.dataprovider import Schema
from funittest.models.policytest import PolicyTest
from funittest.models.parametertest import ParameterTest
from funittest.runner.scenariorunner import Scenario
from funittest.runner.testrunner import Test
from funittest.problems import OnMethodExpectedStateError
from funittest import interpreter
from funittest.core.assertions import TestCaseAssertions

class ExpectedStateGenerator(object, TestCaseAssertions):
    implements(IExpectedStateGenerator)

    failureException = OnMethodExpectedStateError

    state={}

    def set_state(self, key, value):
        self.state.set(key, value)


class Logical(object):
    implements(ILogical)

class Physical(object):
    implements(IPhysical)

class Script(object):
    implements(IScript)

