"""
custom printing out of tracebacks to make them easier to understand
"""

import sys
import traceback
from StringIO import StringIO

def _(arg):
    return arg

def formatExceptionInfo(maxTBlevel=5):
    # Code taken from http://www.linuxjournal.com/article/5821
    cla, exc, trbk = sys.exc_info()
    
    if str(cla):
        excName = str(cla)
    else:
        excName = "no exception name"
    try:
        excName = cla.__name__
    except:
        pass

    excArgs = ()
    try:
        excArgs = exc.__dict__.get("args")
    except:
        pass
        
    excTb = ("no traceback",)
    try:          
        excTb = traceback.format_tb(trbk, maxTBlevel)
    except:
        pass
    return (excName, excArgs, excTb)

def get_traceback(code):
    excName, excArgs, excTb = formatExceptionInfo()
    
    text = ""
    text += excName + "\n"
    try:
        for a in excArgs:
            if a.strip():
                text += a + "\n"
    except:
        text +=str(excArgs) + "\n"
    try:
        for line in excTb:
            if "interp_backend.py" in line:
                pass
            elif "crunchy_exec" in line:
                pass
            else:
                if line.strip():
                    text += line + "\n"
    except:
        text += str(excTb) + "\n"
        
    return text

        
def get_syntax_error(code):
    """
    print out a syntax error
    closely based on showsyntaxerror from the code module
    in the standard library
    """
    filename = "crunchy_exec"
    type, value, sys.last_traceback = sys.exc_info()
    sys.last_type = type
    sys.last_value = value
    if filename and type is SyntaxError:
        # Work hard to stuff the correct filename in the exception
        try:
            msg, (dummy_filename, lineno, offset, line) = value
        except:
            # Not the format we expect; leave it alone
            pass
        else:
            # Stuff in the right filename
            value = SyntaxError(msg, (filename, lineno, offset, line))
            sys.last_value = value
    list = traceback.format_exception_only(type, value)
    retval = StringIO()
    map(retval.write, list)
    return retval.getvalue()
